## ros-foxy-rmw-gurumdds-cpp 1.4.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(rmw_gurumdds_cpp)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake_ros REQUIRED)
find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(gurumdds_cmake_module REQUIRED)

find_package(GurumDDS QUIET MODULE)
if(GurumDDS_FOUND)
  find_package(GurumDDS MODULE)
endif()
if(NOT GurumDDS_FOUND OR GURUMDDS_STATIC_DISABLE)
  ament_package()
  if(NOT GurumDDS_FOUND)
    message(WARNING "Could not find GurumDDS - skipping '${PROJECT_NAME}'")
  else()
    message(STATUS "GurumDDS static rmw implementation explicitly disabled - skipping '${PROJECT_NAME}'")
  endif()
  return()
endif()

find_package(rosidl_typesupport_introspection_c)
if(NOT rosidl_typesupport_introspection_c_FOUND)
  ament_package()
  message(WARNING "Could not find ROSIDL TypeSupport for GurumDDS (rosidl_typesupport_introspection_c) - skipping '${PROJECT_NAME}'")
  return()
endif()

find_package(rosidl_typesupport_introspection_cpp)
if(NOT rosidl_typesupport_introspection_cpp_FOUND)
  ament_package()
  message(WARNING "Could not find ROSIDL TypeSupport for GurumDDS (rosidl_typesupport_introspection_cpp) - skipping '${PROJECT_NAME}'")
  return()
endif()

find_package(rmw REQUIRED)
find_package(rmw_dds_common REQUIRED)
find_package(rosidl_runtime_c REQUIRED)
find_package(rosidl_runtime_cpp REQUIRED)

include_directories(include)
ament_export_include_directories(include ${GurumDDS_INCLUDE_DIR})

include_directories(${GurumDDS_INCLUDE_DIR})
link_directories(${GurumDDS_LIBRARY_DIRS})
add_library(rmw_gurumdds_cpp
  SHARED
  src/demangle.cpp
  src/event_converter.cpp
  src/get_entities.cpp
  src/identifier.cpp
  src/message_converter.cpp
  src/names_and_types_helpers.cpp
  src/namespace_prefix.cpp
  src/qos.cpp
  src/rmw_client.cpp
  src/rmw_compare_gids_equal.cpp
  src/rmw_count.cpp
  src/rmw_event.cpp
  src/rmw_get_implementation_identifier.cpp
  src/rmw_get_serialization_format.cpp
  src/rmw_get_topic_endpoint_info.cpp
  src/rmw_guard_condition.cpp
  src/rmw_init.cpp
  src/rmw_logging.cpp
  src/rmw_node_info_and_types.cpp
  src/rmw_node.cpp
  src/rmw_publisher.cpp
  src/rmw_serialize.cpp
  src/rmw_service_names_and_types.cpp
  src/rmw_service.cpp
  src/rmw_subscription.cpp
  src/rmw_topic_names_and_types.cpp
  src/rmw_wait.cpp
  src/rmw_context_impl.cpp
  src/context_listener_thread.cpp
  src/graph_cache.cpp
  src/serialization_format.cpp
  src/types.cpp
)

ament_target_dependencies(rmw_gurumdds_cpp
  "rcpputils"
  "rcutils"
  "rosidl_typesupport_introspection_c"
  "rosidl_typesupport_introspection_cpp"
  "rmw"
  "rmw_dds_common"
  "rosidl_runtime_c"
  "rosidl_runtime_cpp"
  "GurumDDS")

ament_export_libraries(rmw_gurumdds_cpp)

ament_export_dependencies(
  rosidl_typesupport_introspection_cpp
  rosidl_typesupport_introspection_c
  rosidl_runtime_c
  rosidl_runtime_cpp
  rcpputils
  rcutils
  rmw_dds_common
  rmw
)

register_rmw_implementation(
  "c:rosidl_typesupport_c:rosidl_typesupport_introspection_c"
  "cpp:rosidl_typesupport_cpp:rosidl_typesupport_introspection_cpp")

configure_rmw_library(rmw_gurumdds_cpp)

# Causes the visibility macros to use dllexport rather than dllimport
# which is appropriate when building the library but not consuming it.
target_compile_definitions(rmw_gurumdds_cpp PRIVATE "RMW_GURUMDDS_CPP_BUILDING_LIBRARY")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
  # pass extra include dirs to cppcheck explicitly
  list(APPEND AMENT_LINT_AUTO_EXCLUDE ament_cmake_cppcheck)
  ament_cppcheck(INCLUDE_DIRS ${rcutils_INCLUDE_DIRS})
endif()

ament_package(
  CONFIG_EXTRAS_POST "rmw_gurumdds_cpp-extras.cmake"
)

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS rmw_gurumdds_cpp
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== debian/changelog ===
ros-foxy-rmw-gurumdds-cpp (1.4.0-1focal) focal; urgency=high

  * Add maintainer
  * Add null handling
  * Apply loop to take sequence
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 07 Mar 2023 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.3.1-1focal) focal; urgency=high

  * Remove sleep from entity creation
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 29 Nov 2022 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.3.0-1focal) focal; urgency=high

  * Apply graph cache
  * Apply on_remote_changed callback
  * Avoid string generation on func call
  * Change the behavior of take response to a loop
  * Fix typo
  * Redefine rmw gurumdds identifier
  * Pass extra include dirs to cppcheck explicitly
  * Integrate rmw_gurumdds_shared_cpp into rmw_gurumdds_cpp
  * Contributors: Youngjin Yun, donghee811

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 04 Oct 2022 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.2.3-1focal) focal; urgency=high

  * Add missing guid comparison conditional statement
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Mon, 04 Jul 2022 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.2.2-1focal) focal; urgency=high



 -- Youngjin Yun <youngjin@gurum.cc>  Thu, 26 May 2022 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.2.1-1focal) focal; urgency=high

  * Handle null string
  * Fix rclcpp test(test_serialized_message) failure
  * Contributors: Youngjin Yun, donghee811

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 24 May 2022 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.2.0-1focal) focal; urgency=high

  * Enhanced rpc with sampleinfoex
  * Basic rpc
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Mon, 25 Apr 2022 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.1.6-1focal) focal; urgency=high

  * Remove minimum dds version as raw typesupport removed
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Mon, 25 Apr 2022 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.1.5-1focal) focal; urgency=high

  * Revert raw typesupport patch
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 22 Mar 2022 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.1.4-1focal) focal; urgency=high

  * Remove dead store
  * Adjust minimum dds version
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 16 Mar 2022 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.1.3-1focal) focal; urgency=high

  * Use raw typesupport instead of typesupport
    * To reduce memory usage
  * Contributors: hyeonwoo

 -- Youngjin Yun <youngjin@gurum.cc>  Thu, 10 Feb 2022 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.1.2-1focal) focal; urgency=high

  * Add omitted free
  * Change to delete only the entities created by the user
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Thu, 10 Feb 2022 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.1.1-1focal) focal; urgency=high

  * Update packages to use gurumdds-2.8 & Update README
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Sun, 02 Jan 2022 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.1.0-1focal) focal; urgency=high

  * Remove dds_typesupport from Publisher/Subscriber Info
  * Change the return time when destroying entities
  * Add ommited memory manage code
  * Modify unnecessary code
  * Fix typo
  * Update return value
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 16 Nov 2021 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.0.12-1focal) focal; urgency=high



 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 13 Oct 2021 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.0.11-1focal) focal; urgency=high



 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 12 Oct 2021 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.0.10-1focal) focal; urgency=high

  * Fix unbounded sequence size
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 01 Sep 2021 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.0.9-1focal) focal; urgency=high

  * Revise for lint
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Thu, 22 Jul 2021 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.0.8-1focal) focal; urgency=high

  * Remove datareader listener patch
  * Remove unnecessary operation
  * Contributors: Kumazuma, Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Wed, 21 Jul 2021 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.0.7-1focal) focal; urgency=high

  * Use variable attempt to take the number of times equal to count
  * Check if the queue is empty before using it
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 13 Jul 2021 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.0.6-1focal) focal; urgency=high

  * Update code about build error on windows
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Thu, 06 May 2021 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.0.5-1focal) focal; urgency=high

  * Use dds_free instead of free for dll library
  * Contributors: Youngjin Yun

 -- Youngjin Yun <youngjin@gurum.cc>  Sun, 11 Apr 2021 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.0.4-1focal) focal; urgency=high

  * Change maintainer
  * Use DataReader listener for taking data samples
  * Contributors: junho, youngjin

 -- Youngjin Yun <youngjin@gurum.cc>  Tue, 09 Mar 2021 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.0.3-1focal) focal; urgency=high

  * Update packages to use gurumdds-2.7
  * Contributors: junho

 -- Junho Lee <junho@gurum.cc>  Wed, 18 Nov 2020 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.0.2-1focal) focal; urgency=high

  * Change maintainer
  * Contributors: junho

 -- Junho Lee <junho@gurum.cc>  Tue, 28 Jul 2020 15:00:00 -0000

ros-foxy-rmw-gurumdds-cpp (1.0.1-1focal) focal; urgency=high

  * Renamed rmw_gurumdds_dynamic_cpp to rmw_gurumdds_cpp
  * Renamed rmw_gurumdds_cpp to rmw_gurumdds_static_cpp
  * Contributors: junho

 -- Junho Lee <junho@gurum.cc>  Sun, 05 Jul 2020 15:00:00 -0000



=== debian/control ===
Source: ros-foxy-rmw-gurumdds-cpp
Section: misc
Priority: optional
Maintainer: Youngjin Yun <youngjin@gurum.cc>
Build-Depends: debhelper (>= 9.0.0), gurumdds-2.8, ros-foxy-ament-cmake-ros, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-gurumdds-cmake-module, ros-foxy-rcutils, ros-foxy-rmw, ros-foxy-rmw-dds-common, ros-foxy-rosidl-cmake, ros-foxy-rosidl-generator-dds-idl, ros-foxy-rosidl-runtime-c, ros-foxy-rosidl-runtime-cpp, ros-foxy-rosidl-typesupport-introspection-c, ros-foxy-rosidl-typesupport-introspection-cpp, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rmw-gurumdds-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, gurumdds-2.8, ros-foxy-gurumdds-cmake-module, ros-foxy-rcutils, ros-foxy-rmw, ros-foxy-rmw-dds-common, ros-foxy-rosidl-runtime-c, ros-foxy-rosidl-runtime-cpp, ros-foxy-rosidl-typesupport-introspection-c, ros-foxy-rosidl-typesupport-introspection-cpp, ros-foxy-ros-workspace
Description: Implement the ROS middleware interface using GurumNetworks GurumDDS static code generation in C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rmw-gurumdds-cpp//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
